package cz.muni.gwt.hello.client;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.uibinder.client.UiHandler;
import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;

import cz.muni.gwt.hello.client.rpc.GreetingService;
import cz.muni.gwt.hello.client.rpc.GreetingServiceAsync;

public class GreetingPanel extends Composite {

	private static GreetingPanelUiBinder uiBinder = GWT
			.create(GreetingPanelUiBinder.class);

	interface GreetingPanelUiBinder extends UiBinder<Widget, GreetingPanel> {
	}
	
	@UiField
	TextBox nameBox;
	
	@UiField
	Button addButton;
	
	@UiField
	Button removeButton;
	
	@UiField
	FlowPanel container;

	public GreetingPanel() {
		initWidget(uiBinder.createAndBindUi(this));
		
//		addButton.addClickHandler(new ClickHandler() {
//			@Override
//			public void onClick(ClickEvent event) {
//				container.add(new Label("Hello " + container.getWidgetCount() + "!"));
//			}
//		});
	}
	
	GreetingServiceAsync service = GWT.create(GreetingService.class);
	Timer t;
	
	@UiHandler({"addButton"})
	public void addLabel(ClickEvent event) {
		t = new Timer() {
			@Override
			public void run() {
				service.greetServer(nameBox.getValue(), new AsyncCallback<String>() {
					@Override
					public void onSuccess(String result) {
						container.add(new Label(result));
					}
					
					@Override
					public void onFailure(Throwable caught) {
						Window.alert("Volani servru selhalo!");
					}
				});
			}
		};
		
		t.scheduleRepeating(60000);
		
	}
	
	@UiHandler("removeButton")
	public void removeLabel(ClickEvent event) {
		if (container.getWidgetCount() > 0) {
			container.remove(container.getWidgetCount() -1);
		}
		t.cancel();
	}
	

}
